@ECHO OFF
CLS
ECHO --------------------------------------------------------------------------
ECHO  CalendarScript Installation
ECHO --------------------------------------------------------------------------
ECHO.
IF [%1]==[] GOTO Usage
IF [%2]==[] GOTO Usage
IF [%3]==[] GOTO Usage
IF [%4]==[] GOTO Usage

ECHO open %1>myscript.txt
ECHO %2>>myscript.txt
ECHO %3>>myscript.txt
ECHO cd %4>>myscript.txt
TYPE ftpscript.txt>>myscript.txt

ECHO Beginning Installation...
ECHO.
ECHO Please watch the details of the FTP session to check for errors. If there 
ECHO are problems during the installation, it may need to be done manually!
ECHO.
ECHO The following settings will be used:
ECHO FTP Host Name: %1
ECHO      Username: %2
ECHO      Password: %3
ECHO     Directory: %4
ECHO.
ECHO NOTE: The directory above _MUST_ exist! If it does not, create it manually
ECHO before continuing with this script.
ECHO If there are any problems with the above settings, Press Ctrl-C now to
ECHO abort the installation.
pause
@ECHO ON
ftp -s:myscript.txt
@ECHO OFF
ECHO.
ECHO --------------------------------------------------------------------------
ECHO Installation Complete!
ECHO --------------------------------------------------------------------------
GOTO End

:Usage
ECHO This BATCH file will install CalendarScript for you, using standard FTP
ECHO to transfer the files to your server, create directories, and CHMOD them
ECHO correctly!
ECHO.
ECHO The following information is required to run this script:
ECHO 1. FTP Host name to transfer files to
ECHO 2. Username to login as
ECHO 3. Password
ECHO 4. Directory to place all the files
ECHO.
ECHO Pass these 4 things as arguments to this BATCH file. For example:
ECHO.
ECHO install.bat www.mysite.com username password /home/user/cgi-bin/
ECHO (Using an absolute directory path)
ECHO or
ECHO install.bat www.mysite.com username password htdocs/cgi-bin/
ECHO (Using a relative directory path)
ECHO.
ECHO --------------------------------------------------------------------------

:End
